Qwt User's Guide: QwtPlotZoomer Class Reference

Qwt User's Guide 6.0.1

- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Slots | Signals | Public Member Functions | Protected Member Functions

# QwtPlotZoomer Class Reference

QwtPlotZoomer provides stacked zooming for a plot widget. More...

`#include <qwt_plot_zoomer.h>`

Inheritance diagram for QwtPlotZoomer:
[legend]

List of all members.

## Public Types
enum | DisplayMode { AlwaysOff, AlwaysOn, ActiveOnly }
enum | KeyPatternCode { KeySelect1, KeySelect2, KeyAbort, KeyLeft, KeyRight, KeyUp, KeyDown, KeyRedo, KeyUndo, KeyHome, KeyPatternCount }
enum | MousePatternCode { MouseSelect1, MouseSelect2, MouseSelect3, MouseSelect4, MouseSelect5, MouseSelect6, MousePatternCount }
enum | ResizeMode { Stretch, KeepSize }
enum | RubberBand { NoRubberBand = 0, HLineRubberBand, VLineRubberBand, CrossRubberBand, RectRubberBand, EllipseRubberBand, PolygonRubberBand, UserRubberBand = 100 }
## Public Slots
void | moveBy (double x, double y)
virtual void | moveTo (const QPointF &)
void | setEnabled (bool)
virtual void | zoom (const QRectF &)
virtual void | zoom (int up)
## Signals
void | activated (bool on)
void | appended (const QPointF &pos)
void | appended (const QPoint &pos)
void | changed (const QPolygon &selection)
void | moved (const QPoint &pos)
void | moved (const QPointF &pos)
void | removed (const QPoint &pos)
void | selected (const QPolygon &polygon)
void | selected (const QVector< QPointF > &pa)
void | selected (const QRectF &rect)
void | selected (const QPointF &pos)
void | zoomed (const QRectF &rect)
## Public Member Functions
QwtPlotCanvas * | canvas ()
const QwtPlotCanvas * | canvas () const
virtual void | drawRubberBand (QPainter *) const
virtual void | drawTracker (QPainter *) const
virtual bool | eventFilter (QObject *, QEvent *)
void | initKeyPattern ()
void | initMousePattern (int numButtons)
bool | isActive () const
bool | isEnabled () const
bool | keyMatch (uint pattern, const QKeyEvent *) const
QVector< KeyPattern > & | keyPattern ()
const QVector< KeyPattern > & | keyPattern () const
int | maxStackDepth () const
bool | mouseMatch (uint pattern, const QMouseEvent *) const
const QVector< MousePattern > & | mousePattern () const
QVector< MousePattern > & | mousePattern ()
QWidget * | parentWidget ()
const QWidget * | parentWidget () const
virtual QRect | pickRect () const
QwtPlot * | plot ()
const QwtPlot * | plot () const
| QwtPlotZoomer (QwtPlotCanvas *, bool doReplot=true)
| QwtPlotZoomer (int xAxis, int yAxis, QwtPlotCanvas *, bool doReplot=true)
ResizeMode | resizeMode () const
RubberBand | rubberBand () const
QPen | rubberBandPen () const
QPolygon | selection () const
virtual void | setAxis (int xAxis, int yAxis)
void | setKeyPattern (const QVector< KeyPattern > &)
void | setKeyPattern (uint pattern, int key, int state=Qt::NoButton)
void | setMaxStackDepth (int)
void | setMousePattern (const QVector< MousePattern > &)
void | setMousePattern (uint pattern, int button, int state=Qt::NoButton)
void | setResizeMode (ResizeMode)
void | setRubberBand (RubberBand)
void | setRubberBandPen (const QPen &)
void | setStateMachine (QwtPickerMachine *)
void | setTrackerFont (const QFont &)
void | setTrackerMode (DisplayMode)
void | setTrackerPen (const QPen &)
virtual void | setZoomBase (const QRectF &)
virtual void | setZoomBase (bool doReplot=true)
void | setZoomStack (const QStack< QRectF > &, int zoomRectIndex=-1)
const QwtPickerMachine * | stateMachine () const
QwtPickerMachine * | stateMachine ()
QFont | trackerFont () const
DisplayMode | trackerMode () const
QPen | trackerPen () const
QPoint | trackerPosition () const
virtual QRect | trackerRect (const QFont &) const
int | xAxis () const
int | yAxis () const
QRectF | zoomBase () const
QRectF | zoomRect () const
uint | zoomRectIndex () const
const QStack< QRectF > & | zoomStack () const
## Protected Member Functions
virtual bool | accept (QPolygon &) const
virtual QPolygon | adjustedPoints (const QPolygon &) const
virtual void | append (const QPoint &)
virtual void | begin ()
virtual bool | end (bool ok=true)
QRectF | invTransform (const QRect &) const
QPointF | invTransform (const QPoint &) const
virtual bool | keyMatch (const KeyPattern &, const QKeyEvent *) const
virtual QSizeF | minZoomSize () const
virtual bool | mouseMatch (const MousePattern &, const QMouseEvent *) const
virtual void | move (const QPoint &)
const QPolygon & | pickedPoints () const
virtual void | remove ()
virtual void | rescale ()
virtual void | reset ()
const QWidget * | rubberBandWidget () const
QRectF | scaleRect () const
virtual void | stretchSelection (const QSize &oldSize, const QSize &newSize)
virtual QwtText | trackerText (const QPoint &) const
virtual QwtText | trackerTextF (const QPointF &) const
const QWidget * | trackerWidget () const
QRect | transform (const QRectF &) const
QPoint | transform (const QPointF &) const
virtual void | transition (const QEvent *)
virtual void | updateDisplay ()
virtual void | widgetEnterEvent (QEvent *)
virtual void | widgetKeyPressEvent (QKeyEvent *)
virtual void | widgetKeyReleaseEvent (QKeyEvent *)
virtual void | widgetLeaveEvent (QEvent *)
virtual void | widgetMouseDoubleClickEvent (QMouseEvent *)
virtual void | widgetMouseMoveEvent (QMouseEvent *)
virtual void | widgetMousePressEvent (QMouseEvent *)
virtual void | widgetMouseReleaseEvent (QMouseEvent *)
virtual void | widgetWheelEvent (QWheelEvent *)

## Detailed Description

QwtPlotZoomer provides stacked zooming for a plot widget.

QwtPlotZoomer offers rubberband selections on the plot canvas, translating the selected rectangles into plot coordinates and adjusting the axes to them. Zooming can repeated as often as possible, limited only by maxStackDepth() or minZoomSize(). Each rectangle is pushed on a stack.

Zoom rectangles can be selected depending on selectionFlags() using the mouse or keyboard (QwtEventPattern, QwtPickerMachine). QwtEventPattern::MouseSelect3,QwtEventPattern::KeyUndo, or QwtEventPattern::MouseSelect6,QwtEventPattern::KeyRedo walk up and down the zoom stack. QwtEventPattern::MouseSelect2 or QwtEventPattern::KeyHome unzoom to the initial size.

QwtPlotZoomer is tailored for plots with one x and y axis, but it is allowed to attach a second QwtPlotZoomer for the other axes.

Note:
  The realtime example includes an derived zoomer class that adds scrollbars to the plot canvas.

## Member Enumeration Documentation

enum QwtPicker::DisplayMode`[inherited]`

Display mode.

See also:
  setTrackerMode(), trackerMode(), isActive()

Enumerator:

  AlwaysOff | Display never.
  AlwaysOn | Display always.
  ActiveOnly | Display only when the selection is active.

enum QwtEventPattern::KeyPatternCode`[inherited]`

Symbolic keyboard input codes.

Default initialization:

- KeySelect1
  Qt::Key_Return
- KeySelect2
  Qt::Key_Space
- KeyAbort
  Qt::Key_Escape

- KeyLeft
  Qt::Key_Left
- KeyRight
  Qt::Key_Right
- KeyUp
  Qt::Key_Up
- KeyDown
  Qt::Key_Down

- KeyUndo
  Qt::Key_Minus
- KeyRedo
  Qt::Key_Plus
- KeyHome
  Qt::Key_Escape

enum QwtEventPattern::MousePatternCode`[inherited]`

Symbolic mouse input codes.

The default initialization for 3 button mice is:

- MouseSelect1
  Qt::LeftButton
- MouseSelect2
  Qt::RightButton
- MouseSelect3
  Qt::MidButton
- MouseSelect4
  Qt::LeftButton + Qt::ShiftButton
- MouseSelect5
  Qt::RightButton + Qt::ShiftButton
- MouseSelect6
  Qt::MidButton + Qt::ShiftButton

The default initialization for 2 button mice is:

- MouseSelect1
  Qt::LeftButton
- MouseSelect2
  Qt::RightButton
- MouseSelect3
  Qt::LeftButton + Qt::AltButton
- MouseSelect4
  Qt::LeftButton + Qt::ShiftButton
- MouseSelect5
  Qt::RightButton + Qt::ShiftButton
- MouseSelect6
  Qt::LeftButton + Qt::AltButton + Qt::ShiftButton

The default initialization for 1 button mice is:

- MouseSelect1
  Qt::LeftButton
- MouseSelect2
  Qt::LeftButton + Qt::ControlButton
- MouseSelect3
  Qt::LeftButton + Qt::AltButton
- MouseSelect4
  Qt::LeftButton + Qt::ShiftButton
- MouseSelect5
  Qt::LeftButton + Qt::ControlButton + Qt::ShiftButton
- MouseSelect6
  Qt::LeftButton + Qt::AltButton + Qt::ShiftButton

See also:
  initMousePattern()

enum QwtPicker::ResizeMode`[inherited]`

Controls what to do with the selected points of an active selection when the observed widget is resized.

The default value is QwtPicker::Stretch.

See also:
  setResizeMode()

Enumerator:

  Stretch | All points are scaled according to the new size,.
  KeepSize | All points remain unchanged.

enum QwtPicker::RubberBand`[inherited]`

Rubberband style

The default value is QwtPicker::NoRubberBand.

See also:
  setRubberBand(), rubberBand()

Enumerator:

  NoRubberBand | No rubberband.
  HLineRubberBand | A horizontal line ( only for QwtPicker::PointSelection )
  VLineRubberBand | A vertical line ( only for QwtPicker::PointSelection )
  CrossRubberBand | A crosshair ( only for QwtPicker::PointSelection )
  RectRubberBand | A rectangle ( only for QwtPicker::RectSelection )
  EllipseRubberBand | An ellipse ( only for QwtPicker::RectSelection )
  PolygonRubberBand | A polygon ( only for QwtPicker::&PolygonSelection )
  UserRubberBand | Values >= UserRubberBand can be used to define additional rubber bands.

## Constructor & Destructor Documentation

QwtPlotZoomer::QwtPlotZoomer | ( | QwtPlotCanvas * | canvas,
|  | bool | doReplot = `true`
| ) |  | `[explicit]`

Create a zoomer for a plot canvas.

The zoomer is set to those x- and y-axis of the parent plot of the canvas that are enabled. If both or no x-axis are enabled, the picker is set to QwtPlot::xBottom. If both or no y-axis are enabled, it is set to QwtPlot::yLeft.

The zoomer is initialized with a QwtPickerDragRectMachine, the tracker mode is set to QwtPicker::ActiveOnly and the rubberband is set to QwtPicker::RectRubberBand

Parameters:

  canvas | Plot canvas to observe, also the parent object
  doReplot | Call replot for the attached plot before initializing the zoomer with its scales. This might be necessary, when the plot is in a state with pending scale changes.

See also:
  QwtPlot::autoReplot(), QwtPlot::replot(), setZoomBase()

QwtPlotZoomer::QwtPlotZoomer | ( | int | xAxis,
|  | int | yAxis,
|  | QwtPlotCanvas * | canvas,
|  | bool | doReplot = `true`
| ) |  | `[explicit]`

Create a zoomer for a plot canvas.

The zoomer is initialized with a QwtPickerDragRectMachine, the tracker mode is set to QwtPicker::ActiveOnly and the rubberband is set to QwtPicker;;RectRubberBand

Parameters:

  xAxis | X axis of the zoomer
  yAxis | Y axis of the zoomer
  canvas | Plot canvas to observe, also the parent object
  doReplot | Call replot for the attached plot before initializing the zoomer with its scales. This might be necessary, when the plot is in a state with pending scale changes.

See also:
  QwtPlot::autoReplot(), QwtPlot::replot(), setZoomBase()

## Member Function Documentation

bool QwtPlotZoomer::accept | ( | QPolygon & | pa | ) | const`[protected, virtual]`

Check and correct a selected rectangle.

Reject rectangles with a hight or width < 2, otherwise expand the selected rectangle to a minimum size of 11x11 and accept it.

Returns:
  true If rect is accepted, or has been changed to a accepted rectangle.

Reimplemented from QwtPicker.

void QwtPicker::activated | ( | bool | on | ) | `[signal, inherited]`

A signal indicating, when the picker has been activated. Together with setEnabled() it can be used to implement selections with more than one picker.

Parameters:

  on | True, when the picker has been activated

QPolygon QwtPicker::adjustedPoints | ( | const QPolygon & | points | ) | const`[protected, virtual, inherited]`

Map the pickedPoints() into a selection()

adjustedPoints() maps the points, that have been collected on the parentWidget() into a selection(). The default implementation simply returns the points unmodified.

The reason, why a selection() differs from the picked points depends on the application requirements. F.e. :

- A rectangular selection might need to have a specific aspect ratio only.
- A selection could accept non intersecting polygons only.
- ...

The example below is for a rectangular selection, where the first point is the center of the selected rectangle.

Example

      QPolygon MyPicker::adjustedPoints(const QPolygon &points) const
      {
          QPolygon adjusted;
          if ( points.size() == 2 )
          {
              const int width = qAbs(points[1].x() - points[0].x());
              const int height = qAbs(points[1].y() - points[0].y());

              QRect rect(0, 0, 2 * width, 2 * height);
              rect.moveCenter(points[0]);

              adjusted += rect.topLeft();
              adjusted += rect.bottomRight();
          }
          return adjusted;
      }

void QwtPlotPicker::append | ( | const QPoint & | pos | ) | `[protected, virtual, inherited]`

Append a point to the selection and update rubberband and tracker.

Parameters:

  pos | Additional point

See also:
  isActive, begin(), end(), move(), appended()

Note:
  The appended(const QPoint &), appended(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

void QwtPicker::appended | ( | const QPoint & | pos | ) | `[signal, inherited]`

A signal emitted when a point has been appended to the selection

Parameters:

  pos | Position of the appended point.

See also:
  append(). moved()

void QwtPlotPicker::appended | ( | const QPointF & | pos | ) | `[signal, inherited]`

A signal emitted when a point has been appended to the selection

Parameters:

  pos | Position of the appended point.

See also:
  append(). moved()

void QwtPlotZoomer::begin | ( |  | ) | `[protected, virtual]`

Rejects selections, when the stack depth is too deep, or the zoomed rectangle is minZoomSize().

See also:
  minZoomSize(), maxStackDepth()

Reimplemented from QwtPicker.

QwtPlotCanvas * QwtPlotPicker::canvas | ( |  | ) | `[inherited]`

Return observed plot canvas.

const QwtPlotCanvas * QwtPlotPicker::canvas | ( |  | ) | const`[inherited]`

Return Observed plot canvas.

void QwtPicker::changed | ( | const QPolygon & | selection | ) | `[signal, inherited]`

A signal emitted when the active selection has been changed. This might happen when the observed widget is resized.

Parameters:

  selection | Changed selection

See also:
  stretchSelection()

void QwtPicker::drawRubberBand | ( | QPainter * | painter | ) | const`[virtual, inherited]`

Draw a rubberband, depending on rubberBand()

Parameters:

  painter | Painter, initialized with clip rect

See also:
  rubberBand(), RubberBand

void QwtPicker::drawTracker | ( | QPainter * | painter | ) | const`[virtual, inherited]`

Draw the tracker

Parameters:

  painter | Painter

See also:
  trackerRect(), trackerText()

bool QwtPlotZoomer::end | ( | bool | ok = `true` | ) | `[protected, virtual]`

Expand the selected rectangle to minZoomSize() and zoom in if accepted.

See also:
  accept(), minZoomSize()

Reimplemented from QwtPlotPicker.

bool QwtPicker::eventFilter | ( | QObject * | object,
|  | QEvent * | event
| ) |  | `[virtual, inherited]`

Event filter.

When isEnabled() == true all events of the observed widget are filtered. Mouse and keyboard events are translated into widgetMouse- and widgetKey- and widgetWheel-events. Paint and Resize events are handled to keep rubberband and tracker up to date.

Parameters:

  object | Object to be filtered
  event | Event

See also:
  widgetEnterEvent(), widgetLeaveEvent(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent(), QObject::installEventFilter(), QObject::event()

void QwtEventPattern::initKeyPattern | ( |  | ) | `[inherited]`

Set default mouse patterns.

See also:
  KeyPatternCode

void QwtEventPattern::initMousePattern | ( | int | numButtons | ) | `[inherited]`

Set default mouse patterns, depending on the number of mouse buttons

Parameters:

  numButtons | Number of mouse buttons ( <= 3 )

See also:
  MousePatternCode

QRectF QwtPlotPicker::invTransform | ( | const QRect & | rect | ) | const`[protected, inherited]`

Translate a rectangle from pixel into plot coordinates

Returns:
  Rectangle in plot coordinates

See also:
  transform()

QPointF QwtPlotPicker::invTransform | ( | const QPoint & | pos | ) | const`[protected, inherited]`

Translate a point from pixel into plot coordinates

Returns:
  Point in plot coordinates

See also:
  transform()

bool QwtPicker::isActive | ( |  | ) | const`[inherited]`

A picker is active between begin() and end().

Returns:
  true if the selection is active.

bool QwtPicker::isEnabled | ( |  | ) | const`[inherited]`

Returns:
  true when enabled, false otherwise

See also:
  setEnabled(), eventFilter()

bool QwtEventPattern::keyMatch | ( | uint | pattern,
|  | const QKeyEvent * | event
| ) |  | const`[inherited]`

Compare a key event with an event pattern.

A key event matches the pattern when both have the same key value and in the state value the same key flags (Qt::KeyButtonMask) are set.

Parameters:

  pattern | Index of the event pattern
  event | Key event

Returns:
  true if matches

See also:
  mouseMatch()

bool QwtEventPattern::keyMatch | ( | const KeyPattern & | pattern,
|  | const QKeyEvent * | event
| ) |  | const`[protected, virtual, inherited]`

Compare a key event with an event pattern.

A key event matches the pattern when both have the same key value and in the state value the same key flags (Qt::KeyButtonMask) are set.

Parameters:

  pattern | Key event pattern
  event | Key event

Returns:
  true if matches

See also:
  mouseMatch()

QVector< QwtEventPattern::KeyPattern > & QwtEventPattern::keyPattern | ( |  | ) | `[inherited]`

Return Key patterns.

const QVector< QwtEventPattern::KeyPattern > & QwtEventPattern::keyPattern | ( |  | ) | const`[inherited]`

Return key patterns.

int QwtPlotZoomer::maxStackDepth | ( |  | ) | const

Returns:
  Maximal depth of the zoom stack.

See also:
  setMaxStackDepth()

QSizeF QwtPlotZoomer::minZoomSize | ( |  | ) | const`[protected, virtual]`

Limit zooming by a minimum rectangle.

Returns:
  zoomBase().width() / 10e4, zoomBase().height() / 10e4

bool QwtEventPattern::mouseMatch | ( | uint | pattern,
|  | const QMouseEvent * | event
| ) |  | const`[inherited]`

Compare a mouse event with an event pattern.

A mouse event matches the pattern when both have the same button value and in the state value the same key flags(Qt::KeyButtonMask) are set.

Parameters:

  pattern | Index of the event pattern
  event | Mouse event

Returns:
  true if matches

See also:
  keyMatch()

bool QwtEventPattern::mouseMatch | ( | const MousePattern & | pattern,
|  | const QMouseEvent * | event
| ) |  | const`[protected, virtual, inherited]`

Compare a mouse event with an event pattern.

A mouse event matches the pattern when both have the same button value and in the state value the same key flags(Qt::KeyButtonMask) are set.

Parameters:

  pattern | Mouse event pattern
  event | Mouse event

Returns:
  true if matches

See also:
  keyMatch()

const QVector< QwtEventPattern::MousePattern > & QwtEventPattern::mousePattern | ( |  | ) | const`[inherited]`

Return mouse patterns.

QVector< QwtEventPattern::MousePattern > & QwtEventPattern::mousePattern | ( |  | ) | `[inherited]`

Return ,ouse patterns.

void QwtPlotPicker::move | ( | const QPoint & | pos | ) | `[protected, virtual, inherited]`

Move the last point of the selection

Parameters:

  pos | New position

See also:
  isActive, begin(), end(), append()

Note:
  The moved(const QPoint &), moved(const QDoublePoint &) signals are emitted.

Reimplemented from QwtPicker.

void QwtPlotZoomer::moveBy | ( | double | dx,
|  | double | dy
| ) |  | `[slot]`

Move the current zoom rectangle.

Parameters:

  dx | X offset
  dy | Y offset

Note:
  The changed rectangle is limited by the zoom base

void QwtPlotPicker::moved | ( | const QPointF & | pos | ) | `[signal, inherited]`

A signal emitted whenever the last appended point of the selection has been moved.

Parameters:

  pos | Position of the moved last point of the selection.

See also:
  move(), appended()

void QwtPicker::moved | ( | const QPoint & | pos | ) | `[signal, inherited]`

A signal emitted whenever the last appended point of the selection has been moved.

Parameters:

  pos | Position of the moved last point of the selection.

See also:
  move(), appended()

void QwtPlotZoomer::moveTo | ( | const QPointF & | pos | ) | `[virtual, slot]`

Move the the current zoom rectangle.

Parameters:

  pos | New position

See also:
  QRectF::moveTo()

Note:
  The changed rectangle is limited by the zoom base

const QWidget * QwtPicker::parentWidget | ( |  | ) | const`[inherited]`

Return the parent widget, where the selection happens.

QWidget * QwtPicker::parentWidget | ( |  | ) | `[inherited]`

Return the parent widget, where the selection happens.

const QPolygon & QwtPicker::pickedPoints | ( |  | ) | const`[protected, inherited]`

Return the points, that have been collected so far. The selection() is calculated from the pickedPoints() in adjustedPoints().

Returns:
  Picked points

QRect QwtPicker::pickRect | ( |  | ) | const`[virtual, inherited]`

Find the area of the observed widget, where selection might happen.

Returns:
  parentWidget()->contentsRect()

QwtPlot * QwtPlotPicker::plot | ( |  | ) | `[inherited]`

Return plot widget, containing the observed plot canvas.

const QwtPlot * QwtPlotPicker::plot | ( |  | ) | const`[inherited]`

Return plot widget, containing the observed plot canvas.

void QwtPicker::remove | ( |  | ) | `[protected, virtual, inherited]`

Remove the last point of the selection The removed() signal is emitted.

See also:
  isActive(), begin(), end(), append(), move()

void QwtPicker::removed | ( | const QPoint & | pos | ) | `[signal, inherited]`

A signal emitted whenever the last appended point of the selection has been removed.

See also:
  remove(), appended()

void QwtPlotZoomer::rescale | ( |  | ) | `[protected, virtual]`

Adjust the observed plot to zoomRect()

Note:
  Initiates QwtPlot::replot

void QwtPicker::reset | ( |  | ) | `[protected, virtual, inherited]`

Reset the state machine and terminate (end(false)) the selection

QwtPicker::ResizeMode QwtPicker::resizeMode | ( |  | ) | const`[inherited]`

Returns:
  Resize mode

See also:
  setResizeMode(), ResizeMode

QwtPicker::RubberBand QwtPicker::rubberBand | ( |  | ) | const`[inherited]`

Returns:
  Rubberband style

See also:
  setRubberBand(), RubberBand, rubberBandPen()

QPen QwtPicker::rubberBandPen | ( |  | ) | const`[inherited]`

Returns:
  Rubberband pen

See also:
  setRubberBandPen(), rubberBand()

const QWidget * QwtPicker::rubberBandWidget | ( |  | ) | const`[protected, inherited]`

Returns:
  Widget displaying the rubberband

QRectF QwtPlotPicker::scaleRect | ( |  | ) | const`[protected, inherited]`

Return normalized bounding rect of the axes

See also:
  QwtPlot::autoReplot(), QwtPlot::replot().

void QwtPicker::selected | ( | const QPolygon & | polygon | ) | `[signal, inherited]`

A signal emitting the selected points, at the end of a selection.

Parameters:

  polygon | Selected points

void QwtPlotPicker::selected | ( | const QPointF & | pos | ) | `[signal, inherited]`

A signal emitted in case of selectionFlags() & PointSelection.

Parameters:

  pos | Selected point

void QwtPlotPicker::selected | ( | const QRectF & | rect | ) | `[signal, inherited]`

A signal emitted in case of selectionFlags() & RectSelection.

Parameters:

  rect | Selected rectangle

void QwtPlotPicker::selected | ( | const QVector< QPointF > & | pa | ) | `[signal, inherited]`

A signal emitting the selected points, at the end of a selection.

Parameters:

  pa | Selected points

QPolygon QwtPicker::selection | ( |  | ) | const`[inherited]`

Returns:
  Selected points

See also:
  pickedPoints(), adjustedPoints()

void QwtPlotZoomer::setAxis | ( | int | xAxis,
|  | int | yAxis
| ) |  | `[virtual]`

Reinitialize the axes, and set the zoom base to their scales.

Parameters:

  xAxis | X axis
  yAxis | Y axis

Reimplemented from QwtPlotPicker.

void QwtPicker::setEnabled | ( | bool | enabled | ) | `[slot, inherited]`

En/disable the picker.

When enabled is true an event filter is installed for the observed widget, otherwise the event filter is removed.

Parameters:

  enabled | true or false

See also:
  isEnabled(), eventFilter()

void QwtEventPattern::setKeyPattern | ( | uint | pattern,
|  | int | key,
|  | int | state = `Qt::NoButton`
| ) |  | `[inherited]`

Change one key pattern

Parameters:

  pattern | Index of the pattern
  key | Key
  state | State

See also:
  QKeyEvent

void QwtEventPattern::setKeyPattern | ( | const QVector< KeyPattern > & | pattern | ) | `[inherited]`

Change the key event patterns.

void QwtPlotZoomer::setMaxStackDepth | ( | int | depth | ) |

Limit the number of recursive zoom operations to depth.

A value of -1 set the depth to unlimited, 0 disables zooming. If the current zoom rectangle is below depth, the plot is unzoomed.

Parameters:

  depth | Maximum for the stack depth

See also:
  maxStackDepth()

Note:
  depth doesn't include the zoom base, so zoomStack().count() might be maxStackDepth() + 1.

void QwtEventPattern::setMousePattern | ( | const QVector< MousePattern > & | pattern | ) | `[inherited]`

Change the mouse event patterns.

void QwtEventPattern::setMousePattern | ( | uint | pattern,
|  | int | button,
|  | int | state = `Qt::NoButton`
| ) |  | `[inherited]`

Change one mouse pattern

Parameters:

  pattern | Index of the pattern
  button | Button
  state | State

See also:
  QMouseEvent

void QwtPicker::setResizeMode | ( | ResizeMode | mode | ) | `[inherited]`

Set the resize mode.

The resize mode controls what to do with the selected points of an active selection when the observed widget is resized.

Stretch means the points are scaled according to the new size, KeepSize means the points remain unchanged.

The default mode is Stretch.

Parameters:

  mode | Resize mode

See also:
  resizeMode(), ResizeMode

void QwtPicker::setRubberBand | ( | RubberBand | rubberBand | ) | `[inherited]`

Set the rubberband style

Parameters:

  rubberBand | Rubberband style The default value is NoRubberBand.

See also:
  rubberBand(), RubberBand, setRubberBandPen()

void QwtPicker::setRubberBandPen | ( | const QPen & | pen | ) | `[inherited]`

Set the pen for the rubberband

Parameters:

  pen | Rubberband pen

See also:
  rubberBandPen(), setRubberBand()

void QwtPicker::setStateMachine | ( | QwtPickerMachine * | stateMachine | ) | `[inherited]`

Set a state machine and delete the previous one

Parameters:

  stateMachine | State machine

See also:
  stateMachine()

void QwtPicker::setTrackerFont | ( | const QFont & | font | ) | `[inherited]`

Set the font for the tracker

Parameters:

  font | Tracker font

See also:
  trackerFont(), setTrackerMode(), setTrackerPen()

void QwtPicker::setTrackerMode | ( | DisplayMode | mode | ) | `[inherited]`

Set the display mode of the tracker.

A tracker displays information about current position of the cursor as a string. The display mode controls if the tracker has to be displayed whenever the observed widget has focus and cursor (AlwaysOn), never (AlwaysOff), or only when the selection is active (ActiveOnly).

Parameters:

  mode | Tracker display mode

Warning:
  In case of AlwaysOn, mouseTracking will be enabled for the observed widget.

See also:
  trackerMode(), DisplayMode

void QwtPicker::setTrackerPen | ( | const QPen & | pen | ) | `[inherited]`

Set the pen for the tracker

Parameters:

  pen | Tracker pen

See also:
  trackerPen(), setTrackerMode(), setTrackerFont()

void QwtPlotZoomer::setZoomBase | ( | const QRectF & | base | ) | `[virtual]`

Set the initial size of the zoomer.

base is united with the current scaleRect() and the zoom stack is reinitalized with it as zoom base. plot is zoomed to scaleRect().

Parameters:

  base | Zoom base

See also:
  zoomBase(), scaleRect()

void QwtPlotZoomer::setZoomBase | ( | bool | doReplot = `true` | ) | `[virtual]`

Reinitialized the zoom stack with scaleRect() as base.

Parameters:

  doReplot | Call replot for the attached plot before initializing the zoomer with its scales. This might be necessary, when the plot is in a state with pending scale changes.

See also:
  zoomBase(), scaleRect() QwtPlot::autoReplot(), QwtPlot::replot().

void QwtPlotZoomer::setZoomStack | ( | const QStack< QRectF > & | zoomStack,
|  | int | zoomRectIndex = `-1`
| ) |  |

Assign a zoom stack.

In combination with other types of navigation it might be useful to modify to manipulate the complete zoom stack.

Parameters:

  zoomStack | New zoom stack
  zoomRectIndex | Index of the current position of zoom stack. In case of -1 the current position is at the top of the stack.

Note:
  The zoomed signal might be emitted.

See also:
  zoomStack(), zoomRectIndex()

const QwtPickerMachine * QwtPicker::stateMachine | ( |  | ) | const`[inherited]`

Returns:
  Assigned state machine

See also:
  setStateMachine()

QwtPickerMachine * QwtPicker::stateMachine | ( |  | ) | `[inherited]`

Returns:
  Assigned state machine

See also:
  setStateMachine()

void QwtPicker::stretchSelection | ( | const QSize & | oldSize,
|  | const QSize & | newSize
| ) |  | `[protected, virtual, inherited]`

Scale the selection by the ratios of oldSize and newSize The changed() signal is emitted.

Parameters:

  oldSize | Previous size
  newSize | Current size

See also:
  ResizeMode, setResizeMode(), resizeMode()

QFont QwtPicker::trackerFont | ( |  | ) | const`[inherited]`

Returns:
  Tracker font

See also:
  setTrackerFont(), trackerMode(), trackerPen()

QwtPicker::DisplayMode QwtPicker::trackerMode | ( |  | ) | const`[inherited]`

Returns:
  Tracker display mode

See also:
  setTrackerMode(), DisplayMode

QPen QwtPicker::trackerPen | ( |  | ) | const`[inherited]`

Returns:
  Tracker pen

See also:
  setTrackerPen(), trackerMode(), trackerFont()

QPoint QwtPicker::trackerPosition | ( |  | ) | const`[inherited]`

Returns:
  Current position of the tracker

QRect QwtPicker::trackerRect | ( | const QFont & | font | ) | const`[virtual, inherited]`

Calculate the bounding rectangle for the tracker text from the current position of the tracker

Parameters:

  font | Font of the tracker text

Returns:
  Bounding rectangle of the tracker text

See also:
  trackerPosition()

QwtText QwtPlotPicker::trackerText | ( | const QPoint & | pos | ) | const`[protected, virtual, inherited]`

Translate a pixel position into a position string

Parameters:

  pos | Position in pixel coordinates

Returns:
  Position string

Reimplemented from QwtPicker.

QwtText QwtPlotPicker::trackerTextF | ( | const QPointF & | pos | ) | const`[protected, virtual, inherited]`

Translate a position into a position string.

In case of HLineRubberBand the label is the value of the y position, in case of VLineRubberBand the value of the x position. Otherwise the label contains x and y position separated by a ',' .

The format for the double to string conversion is "%.4f".

Parameters:

  pos | Position

Returns:
  Position string

const QWidget * QwtPicker::trackerWidget | ( |  | ) | const`[protected, inherited]`

Returns:
  Widget displaying the tracker text

QRect QwtPlotPicker::transform | ( | const QRectF & | rect | ) | const`[protected, inherited]`

Translate a rectangle from plot into pixel coordinates

Returns:
  Rectangle in pixel coordinates

See also:
  invTransform()

QPoint QwtPlotPicker::transform | ( | const QPointF & | pos | ) | const`[protected, inherited]`

Translate a point from plot into pixel coordinates

Returns:
  Point in pixel coordinates

See also:
  invTransform()

void QwtPicker::transition | ( | const QEvent * | event | ) | `[protected, virtual, inherited]`

Passes an event to the state machine and executes the resulting commands. Append and Move commands use the current position of the cursor (QCursor::pos()).

Parameters:

  event | Event

void QwtPicker::updateDisplay | ( |  | ) | `[protected, virtual, inherited]`

Update the state of rubberband and tracker label.

void QwtPicker::widgetEnterEvent | ( | QEvent * | event | ) | `[protected, virtual, inherited]`

Handle a enter event for the observed widget.

Parameters:

  event | Qt event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPlotZoomer::widgetKeyPressEvent | ( | QKeyEvent * | ke | ) | `[protected, virtual]`

Qt::Key_Plus zooms in, Qt::Key_Minus zooms out one position on the zoom stack, Qt::Key_Escape zooms out to the zoom base.

Changes the current position on the stack, but doesn't pop any rectangle.

Note:
  The keys codes can be changed, using QwtEventPattern::setKeyPattern: 3, 4, 5

Reimplemented from QwtPicker.

void QwtPicker::widgetKeyReleaseEvent | ( | QKeyEvent * | keyEvent | ) | `[protected, virtual, inherited]`

Handle a key release event for the observed widget.

Passes the event to the state machine.

Parameters:

  keyEvent | Key event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), stateMachine()

void QwtPicker::widgetLeaveEvent | ( | QEvent * | event | ) | `[protected, virtual, inherited]`

Handle a leave event for the observed widget.

Parameters:

  event | Qt event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPicker::widgetMouseDoubleClickEvent | ( | QMouseEvent * | mouseEvent | ) | `[protected, virtual, inherited]`

Handle mouse double click event for the observed widget.

Parameters:

  mouseEvent | Mouse event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPicker::widgetMouseMoveEvent | ( | QMouseEvent * | mouseEvent | ) | `[protected, virtual, inherited]`

Handle a mouse move event for the observed widget.

Parameters:

  mouseEvent | Mouse event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPicker::widgetMousePressEvent | ( | QMouseEvent * | mouseEvent | ) | `[protected, virtual, inherited]`

Handle a mouse press event for the observed widget.

Parameters:

  mouseEvent | Mouse event

See also:
  eventFilter(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetWheelEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

void QwtPlotZoomer::widgetMouseReleaseEvent | ( | QMouseEvent * | me | ) | `[protected, virtual]`

Qt::MidButton zooms out one position on the zoom stack, Qt::RightButton to the zoom base.

Changes the current position on the stack, but doesn't pop any rectangle.

Note:
  The mouse events can be changed, using QwtEventPattern::setMousePattern: 2, 1

Reimplemented from QwtPicker.

void QwtPicker::widgetWheelEvent | ( | QWheelEvent * | wheelEvent | ) | `[protected, virtual, inherited]`

Handle a wheel event for the observed widget.

Move the last point of the selection in case of isActive() == true

Parameters:

  wheelEvent | Wheel event

See also:
  eventFilter(), widgetMousePressEvent(), widgetMouseReleaseEvent(), widgetMouseDoubleClickEvent(), widgetMouseMoveEvent(), widgetKeyPressEvent(), widgetKeyReleaseEvent()

int QwtPlotPicker::xAxis | ( |  | ) | const`[inherited]`

Return x axis.

int QwtPlotPicker::yAxis | ( |  | ) | const`[inherited]`

Return y axis.

void QwtPlotZoomer::zoom | ( | int | offset | ) | `[virtual, slot]`

Zoom in or out.

Activate a rectangle on the zoom stack with an offset relative to the current position. Negative values of offest will zoom out, positive zoom in. A value of 0 zooms out to the zoom base.

Parameters:

  offset | Offset relative to the current position of the zoom stack.

Note:
  The zoomed signal is emitted.

See also:
  zoomRectIndex()

void QwtPlotZoomer::zoom | ( | const QRectF & | rect | ) | `[virtual, slot]`

Zoom in.

Clears all rectangles above the current position of the zoom stack and pushs the normalized rect on it.

Note:
  If the maximal stack depth is reached, zoom is ignored.
  The zoomed signal is emitted.

QRectF QwtPlotZoomer::zoomBase | ( |  | ) | const

Returns:
  Initial rectangle of the zoomer

See also:
  setZoomBase(), zoomRect()

void QwtPlotZoomer::zoomed | ( | const QRectF & | rect | ) | `[signal]`

A signal emitting the zoomRect(), when the plot has been zoomed in or out.

Parameters:

  rect | Current zoom rectangle.

QRectF QwtPlotZoomer::zoomRect | ( |  | ) | const

Rectangle at the current position on the zoom stack.

See also:
  zoomRectIndex(), scaleRect().

uint QwtPlotZoomer::zoomRectIndex | ( |  | ) | const

Returns:
  Index of current position of zoom stack.

const QStack< QRectF > & QwtPlotZoomer::zoomStack | ( |  | ) | const

Return the zoom stack. zoomStack()[0] is the zoom base, zoomStack()[1] the first zoomed rectangle.

See also:
  setZoomStack(), zoomRectIndex()